# Basic RAG Cookbook

Welcome to the Basic RAG Cookbook! This repository is dedicated to showcasing how to utilize the Retrieval-Augmented
Generation (RAG) model for various applications using custom and few-shot prompts. For in depth understanding of RAG
pipelines, chains, and prompts
check [RAG-Pipelines.md](https://github.com/arjbingly/Capstone_5/blob/main/cookbook/Basic-RAG/RAG-PIPELINES.md)

### Contents:

- **BasicRAG_CustomPrompt.py**: Learn to integrate custom prompts into Basic RAG for tailored query responses.
- **BasicRAG_FewShotPrompt.py**: Explore the use of few-shot prompts to enhance Basic RAG's contextual understanding.
- **BasicRAG_ingest.py**: Demonstrates the process of ingesting PDF files, making them searchable via Basic RAG.
- **BasicRAG_stuff.py**: A guide on leveraging the stuff chain with Basic RAG for enriched data processing.
- **BasicRAG_refine.py**: Discover how to refine queries using the refine chain for more precise results with Basic RAG.
